package it.tref.liferay.mapit.map.messaging;

import it.tref.liferay.mapit.constants.PortletConfiguration;
import it.tref.liferay.mapit.map.util.MapItPluginEventUtil;
import it.tref.liferay.mapit.plugin.event.MapItPluginEvent.MapItPluginEventType;

import com.liferay.portal.kernel.messaging.BaseMessageListener;
import com.liferay.portal.kernel.messaging.Message;
import com.liferay.portal.kernel.messaging.MessageBusUtil;
import com.liferay.portal.kernel.search.Field;
import com.liferay.portal.kernel.util.StringUtil;

public class DestinationsResolverMessageListener extends BaseMessageListener {

  @Override
  protected void doReceive(Message message) throws Exception {

    String content = message.getString(Field.CONTENT);
    String pluginIdsString = message.getString(PortletConfiguration.PLUGIN_IDS);
    MapItPluginEventType mapItPluginEventType = MapItPluginEventType.parse(content);

    String[] pluginIds = StringUtil.split(pluginIdsString);


    String[] destinationNames = MapItPluginEventUtil.getDestinationNames(pluginIds, mapItPluginEventType);

    Message responseMessage = MessageBusUtil.createResponseMessage(message, StringUtil.merge(destinationNames));
    MessageBusUtil.sendMessage(message.getResponseDestinationName(), responseMessage);
  }
}
